﻿Public Class Form1
    ' Use the BackgroundWorker to perform a long task.
    Private Sub btnGo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGo.Click
        If (btnGo.Text = "Go") Then
            ' Start the process.
            lblStatus.Text = "Working..."
            btnGo.Text = "Stop"
            prgPercentComplete.Value = 0
            prgPercentComplete.Visible = True

            ' Start the BackgroundWorker.
            bgwLongTask.RunWorkerAsync()
        Else
            ' Stop the process.
            bgwLongTask.CancelAsync()
        End If
    End Sub

    ' Perform the long task.
    Private Sub bgwLongTask_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles bgwLongTask.DoWork
        ' Spend 10 seconds doing nothing.
        For i As Integer = 1 To 10
            ' If we should stop, do so.
            If (bgwLongTask.CancellationPending) Then
                ' Indicate that the task was canceled.
                e.Cancel = True
                Exit For
            End If

            ' Sleep.
            System.Threading.Thread.Sleep(1000)

            ' Notify the UI thread of our progress.
            bgwLongTask.ReportProgress(i * 10)
        Next i
    End Sub

    ' Update the progress bar.
    Private Sub bgwLongTask_ProgressChanged(ByVal sender As System.Object, ByVal e As System.ComponentModel.ProgressChangedEventArgs) Handles bgwLongTask.ProgressChanged
        prgPercentComplete.Value = e.ProgressPercentage
    End Sub

    ' The long task is done.
    Private Sub bgwLongTask_RunWorkerCompleted(ByVal sender As System.Object, ByVal e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles bgwLongTask.RunWorkerCompleted
        If (e.Cancelled) Then
            lblStatus.Text = "Canceled"
        Else
            lblStatus.Text = "Finished"
        End If
        btnGo.Text = "Go"
        prgPercentComplete.Visible = False
    End Sub

    ' Display the current time.
    Private Sub tmrClock_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrClock.Tick
        lblClock.Text = DateTime.Now.ToString("T")
    End Sub
End Class
